# zlib_stream::basic_zip_streambuf< charT, traits > Class Template Reference

A stream decorator that takes raw input and zips it to a ostream. More...

`#include <zipstreamimpl.h>`

Inheritance diagram for zlib_stream::basic_zip_streambuf< charT, traits >:
[legend]
Collaboration diagram for zlib_stream::basic_zip_streambuf< charT, traits >:
[legend]

List of all members.

## Public Types
typedef byte_type * | byte_buffer_type
typedef unsigned char | byte_type
typedef std::vector< byte_type > | byte_vector_type
typedef char | char_type
typedef std::vector< char_type > | char_vector_type
typedef int | int_type
typedef std::basic_ostream < charT, traits > & | ostream_reference
## Public Member Functions
| basic_zip_streambuf (ostream_reference ostream, int level, EStrategy strategy, int window_size, int memory_level, size_t buffer_size)
| ~basic_zip_streambuf (void)
std::streamsize | flush (void)
unsigned long | get_crc (void) const
unsigned long | get_in_size (void) const
ostream_reference | get_ostream (void) const
long | get_out_size (void) const
int | get_zerr (void) const
int_type | overflow (int_type c)
int | sync (void)

## Detailed Description

### template<class charT, class traits = std::char_traits<charT>>
class zlib_stream::basic_zip_streambuf< charT, traits >

A stream decorator that takes raw input and zips it to a ostream.

The class wraps up the inflate method of the zlib library 1.1.4 http://www.gzip.org/zlib/

## Member Typedef Documentation

template<class charT , class traits = std::char_traits<charT>>

typedef byte_type* zlib_stream::basic_zip_streambuf< charT, traits >::byte_buffer_type

template<class charT , class traits = std::char_traits<charT>>

typedef unsigned char zlib_stream::basic_zip_streambuf< charT, traits >::byte_type

template<class charT , class traits = std::char_traits<charT>>

typedef std::vector<byte_type> zlib_stream::basic_zip_streambuf< charT, traits >::byte_vector_type

template<class charT , class traits = std::char_traits<charT>>

typedef char zlib_stream::basic_zip_streambuf< charT, traits >::char_type

Reimplemented in zlib_stream::basic_zip_ostream< charT, traits >.

template<class charT , class traits = std::char_traits<charT>>

typedef std::vector<char_type> zlib_stream::basic_zip_streambuf< charT, traits >::char_vector_type

template<class charT , class traits = std::char_traits<charT>>

typedef int zlib_stream::basic_zip_streambuf< charT, traits >::int_type

template<class charT , class traits = std::char_traits<charT>>

typedef std::basic_ostream<charT, traits>& zlib_stream::basic_zip_streambuf< charT, traits >::ostream_reference

Reimplemented in zlib_stream::basic_zip_ostream< charT, traits >.

## Constructor & Destructor Documentation

template<class charT , class traits = std::char_traits<charT>>

zlib_stream::basic_zip_streambuf< charT, traits >::basic_zip_streambuf | ( | ostream_reference | ostream,
|  | int | level,
|  | EStrategy | strategy,
|  | int | window_size,
|  | int | memory_level,
|  | size_t | buffer_size |
| ) |  |  |

template<class charT , class traits = std::char_traits<charT>>

zlib_stream::basic_zip_streambuf< charT, traits >::~basic_zip_streambuf | ( | void |  | ) |

## Member Function Documentation

template<class charT , class traits = std::char_traits<charT>>

std::streamsize zlib_stream::basic_zip_streambuf< charT, traits >::flush | ( | void |  | ) |

template<class charT , class traits = std::char_traits<charT>>

unsigned long zlib_stream::basic_zip_streambuf< charT, traits >::get_crc | ( | void |  | ) | const`[inline]`

template<class charT , class traits = std::char_traits<charT>>

unsigned long zlib_stream::basic_zip_streambuf< charT, traits >::get_in_size | ( | void |  | ) | const`[inline]`

template<class charT , class traits = std::char_traits<charT>>

ostream_reference zlib_stream::basic_zip_streambuf< charT, traits >::get_ostream | ( | void |  | ) | const`[inline]`

template<class charT , class traits = std::char_traits<charT>>

long zlib_stream::basic_zip_streambuf< charT, traits >::get_out_size | ( | void |  | ) | const`[inline]`

template<class charT , class traits = std::char_traits<charT>>

int zlib_stream::basic_zip_streambuf< charT, traits >::get_zerr | ( | void |  | ) | const`[inline]`

template<class charT , class traits = std::char_traits<charT>>

int_type zlib_stream::basic_zip_streambuf< charT, traits >::overflow | ( | int_type | c | ) |

template<class charT , class traits = std::char_traits<charT>>

int zlib_stream::basic_zip_streambuf< charT, traits >::sync | ( | void |  | ) |

The documentation for this class was generated from the following file:

- zipstreamimpl.h